//enum EnvelopeDefaultsUniqueRecipientSelectorType {
//
//}

enum RecipientType {
  recipientTypeNotSet,
  recipientTypeAgent,
  recipientTypeCC,
  recipientTypeCertifiedDelivery,
  recipientTypeEditor,
  recipientTypeIntermediary,
  recipientTypeInPersonSigner,
  recipientTypeSigner,
}

class CustomFields {}

class RecipientDefault {
  String inPersonSignerName;
  String recipientEmail;
  String recipientId;
  String recipientName;
  String recipientRoleName;
//  String recipientSelectorType;
  RecipientType recipientType;
  bool removeRecipient;

  RecipientDefault(
      {required this.inPersonSignerName,
      required this.recipientEmail,
      required this.recipientId,
      required this.recipientName,
      required this.recipientRoleName,
      required this.recipientType,
      this.removeRecipient = false});

  toMap() {
    return {
      "inPersonSignerName": inPersonSignerName,
      "recipientEmail": recipientEmail,
      "recipientId": recipientId,
      "recipientName": recipientName,
      "recipientRoleName": recipientRoleName,
      "recipientType": recipientType.index,
      "removeRecipient": removeRecipient,
    };
  }
}

class EnvelopeDefaults {
  String emailBlurb;
  String emailSubject;
  String envelopeTitle;
  List<RecipientDefault> recipientDefaults;
  Map<String, String> tabValueDefaults;

  EnvelopeDefaults(
      {required this.emailBlurb,
      required this.emailSubject,
      required this.envelopeTitle,
      required this.recipientDefaults,
      required this.tabValueDefaults});

  toMap() {
    return {
      "emailBlurb": emailBlurb,
      "emailSubject": emailSubject,
      "envelopeTitle": envelopeTitle,
      "recipientDefaults": recipientDefaults.map((recip) {
        return recip.toMap();
      }).toList(),
      "tabValueDefaults": tabValueDefaults,
    };
  }
}
